'From Haver 5.0 [latest update: #4559] on 22 March 2021 at 6:11:53 pm'!
'Description I test the ported transactions module.

I am a white-box test.'!
!provides: 'TransactionsTest' 1 12!
!requires: 'Transactions' 1 18 nil!
SystemOrganization addCategory: 'TransactionsTest'!


!moduleCreation: TransactionsTest!
Modules newEnvironment: #TransactionsTest!

!interfacesOf: TransactionsTest!
Modules environment: #TransactionsTest ::
	interface: #API exporting: #() ::
	interface: #SPI aliasFor: #API!

!importsOf: TransactionsTest!
Modules environment: #TransactionsTest :: 
	import: #API of: Modules>>#Transactions!

!classDefinition: (Modules>>#TransactionsTest>>#TransactionManagerTest) category: 'TransactionsTest'!
TestCase subclass: #TransactionManagerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TransactionsTest'
	inModule: #TransactionsTest!
!classDefinition: (Modules>>#TransactionsTest>>#TransactionManagerTest) class category: 'TransactionsTest'!
(Modules>>#TransactionsTest>>#TransactionManagerTest) class
	instanceVariableNames: ''!

!classDefinition: (Modules>>#TransactionsTest>>#TransactiveTestObject) category: 'TransactionsTest'!
(Modules>>#Transactions>>#TransactiveObject) subclass: #TransactiveTestObject
	instanceVariableNames: 'i0 i1'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TransactionsTest'
	inModule: #TransactionsTest!
!classDefinition: (Modules>>#TransactionsTest>>#TransactiveTestObject) class category: 'TransactionsTest'!
(Modules>>#TransactionsTest>>#TransactiveTestObject) class
	instanceVariableNames: ''!


!(Modules>>#TransactionsTest>>#TransactionManagerTest) commentStamp: '<historical>' prior: 0!
I test the transaction manager.!

!(Modules>>#TransactionsTest>>#TransactiveTestObject) commentStamp: '<historical>' prior: 0!
I am a transactive test object.!

!(Modules>>#TransactionsTest>>#TransactionManagerTest) methodsFor: 'testing' stamp: 'KLG 2/9/2019 19:26:31'!
test2Commits
	"Test 2 commits in a row."

	| to newArray newObject |
	to _ TransactiveTestObject new.
	TransactionManager begin.
	to iv0: (newArray _ { newObject _ Object new }).
	self 
		assert: newArray equals: to iv0;
		assert: (TransactionManager isRegistered: newArray);
		assert: (TransactionManager isRegistered: newObject).
	newArray at: 1 put: (newObject _ 'One').
	self
		assert: (newArray at: 1) equals: newObject;
		assert: (TransactionManager isRegistered: newObject).
	TransactionManager commit.
	self
		assert: newArray equals: to iv0;
		assert: (newArray at: 1) equals: newObject;
		assert: (TransactionManager isRegistered: newObject).
	
	TransactionManager begin.
	to iv0: (newArray _ { newObject _ Object new }).
	self 
		assert: newArray equals: to iv0;
		"FIXME: newArray does not get registered because, we do not set test object (to) to read only."
		assert: (TransactionManager isRegistered: newArray);
		assert: (TransactionManager isRegistered: newObject).
	newArray at: 1 put: (newObject _ 'Two').
	self
		assert: (newArray at: 1) equals: newObject;
		assert: (TransactionManager isRegistered: newObject).
	TransactionManager commit.
	self
		assert: newArray equals: to iv0;
		assert: (newArray at: 1) equals: newObject;
		assert: (TransactionManager isRegistered: newObject).
! !

!(Modules>>#TransactionsTest>>#TransactionManagerTest) methodsFor: 'testing' stamp: 'KLG 2/7/2019 21:18:05'!
testAbort
	"Test aborting a transaction."

	| to old0 old1 newArray newObject oldObject |
	to _ TransactiveTestObject new.
	old0 _ to iv0.
	old1 _ to iv1.
	TransactionManager begin.
	to iv0: (newArray _ { oldObject _ Object new }).
	newArray at: 1 put: (newObject _ 'One').
	self assert: (newArray at: 1) equals: newObject.
	TransactionManager abort.
	self
		assert: to iv0 == old0;
		assert: to iv1 == old1;
		assert: (newArray at: 1) == oldObject! !

!(Modules>>#TransactionsTest>>#TransactionManagerTest) methodsFor: 'testing' stamp: 'KLG 1/29/2019 15:28:57'!
testActiveTransactionCreation
	"Test that we can create a transaction for the current process."

	self
		assert: 
			TransactionManager active notNil;
		assert:
			TransactionManager active == TransactionManager active! !

!(Modules>>#TransactionsTest>>#TransactionManagerTest) methodsFor: 'testing' stamp: 'KLG 2/7/2019 04:16:46'!
testBegin
	"Test beginning a transaction."

	| to newArray newObject |
	to _ TransactiveTestObject new.
	TransactionManager begin.
	to iv0: (newArray _ { newObject _ Object new }).
	self 
		assert: newArray equals: to iv0;
		assert: (TransactionManager isRegistered: newArray);
		assert: (TransactionManager isRegistered: newObject).
	newArray at: 1 put: (newObject _ 'One').
	self
		assert: (newArray at: 1) equals: newObject;
		assert: (TransactionManager isRegistered: newObject)
	! !

!(Modules>>#TransactionsTest>>#TransactionManagerTest) methodsFor: 'testing' stamp: 'KLG 2/8/2019 18:41:39'!
testCommit
	"Test commiting a transaction."

	| to newArray newObject |
	to _ TransactiveTestObject new.
	TransactionManager begin.
	to iv0: (newArray _ { newObject _ Object new }).
	self 
		assert: newArray equals: to iv0;
		assert: (TransactionManager isRegistered: newArray);
		assert: (TransactionManager isRegistered: newObject).
	newArray at: 1 put: (newObject _ 'One').
	self
		assert: (newArray at: 1) equals: newObject;
		assert: (TransactionManager isRegistered: newObject).
	TransactionManager commit.
	self
		assert: (newArray at: 1) equals: newObject;
		assert: (TransactionManager isRegistered: newObject).
! !

!(Modules>>#TransactionsTest>>#TransactionManagerTest) methodsFor: 'testing' stamp: 'KLG 1/3/2021 21:45:05'!
testRegistration
	"Test that we can register an object."

	| transaction to |
	transaction _ TransactionManager register: TransactiveObject new.
	self assert: transaction == TransactionManager active.
	transaction _ TransactionManager register: (to _ TransactiveTestObject new).
	self assert: transaction == TransactionManager active.
	self assert: (TransactionManager isRegistered: to)
	! !

!(Modules>>#TransactionsTest>>#TransactionManagerTest) methodsFor: 'testing' stamp: 'KLG 1/26/2019 16:26:19'!
testSingleton
	"I test the transaction managers singleton implementation."

	self assert: TransactionManager uniqueInstance == TransactionManager uniqueInstance ! !

!(Modules>>#TransactionsTest>>#TransactionManagerTest) methodsFor: 'running' stamp: 'KLG 1/31/2019 19:12:26'!
setUp
	"Initialize the TransactionManager"

	TransactionManager initialize! !

!(Modules>>#TransactionsTest>>#TransactionManagerTest) methodsFor: 'running' stamp: 'KLG 6/20/2019 19:39:42'!
tearDown
	"Tear down global write barrier handling."

	ModificationForbidden resetModificationForbiddenHandler! !

!(Modules>>#TransactionsTest>>#TransactiveTestObject) methodsFor: 'initialization' stamp: 'KLG 1/30/2019 19:52:25'!
initialize
	"Initialize our two instance variables."

	super initialize.
	i0 _ OrderedCollection new.
	i1 _ Set new! !

!(Modules>>#TransactionsTest>>#TransactiveTestObject) methodsFor: 'accessing' stamp: 'KLG 1/30/2019 19:55:10'!
iv0
	^ i0! !

!(Modules>>#TransactionsTest>>#TransactiveTestObject) methodsFor: 'accessing' stamp: 'KLG 1/31/2019 19:17:05'!
iv0: anObject
	
	i0 _ anObject ! !

!(Modules>>#TransactionsTest>>#TransactiveTestObject) methodsFor: 'accessing' stamp: 'KLG 1/30/2019 20:03:02'!
iv1
	^ i1! !
